apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: kind-test-operator
  namespace: {{ buildns }}
spec:
  params:
  - default: docker.io/curlimages/curl:7.72.0
    description: Image providing curl, pulling binaries required by this Task
    name: init_image
    type: string
  - default: 1.21.1
    description: Kubernetes cluster version, downloading proper client and setting up KinD cluster
    name: k8s_version
    type: string
  - default: 0.11.1
    description: KIND version
    name: kind_version
    type: string
  - default: docker.io/kindest/node
    description: KinD Node Image repository, including Kubernetes in Docker runtime (no tag required, will be set based in k8s_version)
    name: kind_node_image
    type: string
  - default: {{ tekton_docker_builder_image }}
    description: The location of the docker builder image.
    name: builderimage
    type: string
  - default: {{ tekton_docker_dind_image }}
    description: The location of the docker-in-docker image.
    name: dindimage
    type: string
  steps:
  - args:
    - -c
    - |
{% if do_debugs %}
        set -x;
{% endif %}
        # install kubectl
        curl -o /ci-bin/kubectl -fsL \
              https://dl.k8s.io/release/v$(params.k8s_version)/bin/linux/amd64/kubectl;
        chmod +x /ci-bin/kubectl;
        # install kind
        curl -o /ci-bin/kind -fsL \
            https://github.com/kubernetes-sigs/kind/releases/download/v$(params.kind_version)/kind-linux-amd64;
        chmod +x /ci-bin/kind;
        test -x /ci-bin/kind -a -x /ci-bin/kubectl;
        exit $?;
    command:
    - /bin/sh
    image: $(params.init_image)
    name: setup
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /ci-bin
      name: temp-bin
  - args:
    - -c
    - |
{% if do_debugs %}
        set -x;
{% endif %}
        export PATH=/ci-bin:$PATH;

        # start kube cluster
        kind create cluster --image=$(params.kind_node_image):v$(params.k8s_version);

        # test cluster OK
        kubectl get nodes
        if ! kubectl get nodes 2>&1 | grep Ready >/dev/null; then
            echo K8S KO - bailing out;
            exit 1;
        fi;

        # deploy controller
        kubectl create ns opsperator;
        kubectl create -f $(workspaces.source.path)/deploy/kubernetes/crd.yaml;
        kubectl create -f $(workspaces.source.path)/deploy/kubernetes/rbac.yaml;
        kubectl create -f $(workspaces.source.path)/deploy/kubernetes/namespace.yaml;
        grep -vE ' (resources|limits|memory|cpu|nodeSelector|node-role.kubernetes.io/.*):( |$)' \
            $(workspaces.source.path)/deploy/kubernetes/run-ephemeral.yaml | kubectl apply -f-;
        echo Waiting for operator to start ...;
        while true;
        do
            kubectl get pods -n opsperator;
            kubectl get pods -n opsperator | grep 1/1 >/dev/null && break;
            sleep 10;
        done;

        # dummy test for controller
        echo Creating test resource ...;
        kubectl create ns collab-demo;
        sed -e 's|do_network_policy.*|do_network_policy: false|' \
            -e 's|do_exporters.*|do_exporters: false|' \
            $(workspaces.source.path)/deploy/kubernetes/cr/draw.yaml | kubectl apply -f-;
        echo Waiting for draw to start ...;
        while true;
        do
            kubectl get draw -n collab-demo;
            kubectl get draw -n collab-demo -o yaml | grep -A20 'status:' | grep 'ready: true' >/dev/null && break;
            sleep 10;
        done;

        # check assets created by controller
        echo Checking pods:;
        kubectl get pods -n collab-demo -o wide;
        echo Checking ingress:;
        kubectl get ingress,svc -n collab-demo;

        echo Done;
        exit 0;
    command:
    - /bin/sh
    env:
    - name: DOCKER_HOST
      value: tcp://localhost:2376
    - name: DOCKER_TLS_VERIFY
      value: '1'
    - name: DOCKER_CERT_PATH
      value: /certs/client
    image: $(params.builderimage)
    name: kind
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /ci-bin
      name: temp-bin
    - mountPath: /certs/client
      name: dind-certs
  sidecars:
  - args:
    - --storage-driver=vfs
    - --userland-proxy=false
{% if do_debugs %}
    - --debug
{% endif %}
    env:
    - name: DOCKER_TLS_CERTDIR
      value: /certs
    image: $(params.dindimage)
    name: dind
    readinessProbe:
      periodSeconds: 1
      exec:
        command:
        - ls
        - /certs/client/ca.pem
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_dind_cpu_limit }}"
        memory: {{ tekton_docker_dind_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_dind_cpu_request }}"
        memory: {{ tekton_docker_dind_memory_request }}
{% else %}
    resources: {}
{% endif %}
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /certs/client
      name: dind-certs
  volumes:
  - name: temp-bin
    emptyDir: {}
  - name: dind-certs
    emptyDir: {}
  workspaces:
  - name: source
